package ru.landrafhomyak.utility.reference_counter

import kotlinx.atomicfu.AtomicLong
import kotlinx.atomicfu.atomic
import kotlinx.atomicfu.getAndUpdate
import kotlinx.atomicfu.update

internal actual class _AtomicLong {
	val _atomicfu: AtomicLong

	actual constructor(initial: Long) {
		this._atomicfu = atomic(0L)
	}

	actual fun get() =
		this._atomicfu.value

	actual inline fun update(operator: (Long) -> Long) =
		this._atomicfu.update(operator)

	actual inline fun getAndUpdate(operator: (Long) -> Long) =
		this._atomicfu.getAndUpdate(operator)

	actual fun compareAndSet(expected: Long, newValue: Long): Boolean =
		this._atomicfu.compareAndSet(expected, newValue)
}